diff --git a/src/libs/zbxdbcache/dbsync.c b/src/libs/zbxdbcache/dbsync.c
index 05eae2a..2fdd542 100644
--- a/src/libs/zbxdbcache/dbsync.c
+++ b/src/libs/zbxdbcache/dbsync.c
@@ -505,7 +505,7 @@ static int	dbsync_compare_host(ZBX_DC_HOST *host, const DB_ROW dbrow)
 		return FAIL;
 	}
 
-	if (FAIL == dbsync_compare_uchar(dbrow[22], host->status))
+	if (FAIL == dbsync_compare_uchar(dbrow[14], host->status))
 	{
 		host->update_items = 1;
 		return FAIL;
@@ -516,17 +516,17 @@ static int	dbsync_compare_host(ZBX_DC_HOST *host, const DB_ROW dbrow)
 	if (FAIL == dbsync_compare_str(dbrow[2], host->host))
 		return FAIL;
 
-	if (FAIL == dbsync_compare_str(dbrow[23], host->name))
+	if (FAIL == dbsync_compare_str(dbrow[15], host->name))
 		return FAIL;
 
 #if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
-	if (FAIL == dbsync_compare_str(dbrow[31], host->tls_issuer))
+	if (FAIL == dbsync_compare_str(dbrow[23], host->tls_issuer))
 		return FAIL;
 
-	if (FAIL == dbsync_compare_str(dbrow[32], host->tls_subject))
+	if (FAIL == dbsync_compare_str(dbrow[24], host->tls_subject))
 		return FAIL;
 
-	if ('\0' == *dbrow[33] || '\0' == *dbrow[34])
+	if ('\0' == *dbrow[25] || '\0' == *dbrow[26])
 	{
 		if (NULL != host->tls_dc_psk)
 			return FAIL;
@@ -536,18 +536,18 @@ static int	dbsync_compare_host(ZBX_DC_HOST *host, const DB_ROW dbrow)
 		if (NULL == host->tls_dc_psk)
 			return FAIL;
 
-		if (FAIL == dbsync_compare_str(dbrow[33], host->tls_dc_psk->tls_psk_identity))
+		if (FAIL == dbsync_compare_str(dbrow[25], host->tls_dc_psk->tls_psk_identity))
 			return FAIL;
 
-		if (FAIL == dbsync_compare_str(dbrow[34], host->tls_dc_psk->tls_psk))
+		if (FAIL == dbsync_compare_str(dbrow[26], host->tls_dc_psk->tls_psk))
 			return FAIL;
 	}
 
 #endif
-	if (FAIL == dbsync_compare_uchar(dbrow[29], host->tls_connect))
+	if (FAIL == dbsync_compare_uchar(dbrow[21], host->tls_connect))
 		return FAIL;
 
-	if (FAIL == dbsync_compare_uchar(dbrow[30], host->tls_accept))
+	if (FAIL == dbsync_compare_uchar(dbrow[22], host->tls_accept))
 		return FAIL;
 
 	/* IPMI hosts */
@@ -582,10 +582,10 @@ static int	dbsync_compare_host(ZBX_DC_HOST *host, const DB_ROW dbrow)
 	/* proxies */
 	if (NULL != (proxy = (ZBX_DC_PROXY *)zbx_hashset_search(&dbsync_env.cache->proxies, &host->hostid)))
 	{
-		if (FAIL == dbsync_compare_str(dbrow[31 + ZBX_HOST_TLS_OFFSET], proxy->proxy_address))
+		if (FAIL == dbsync_compare_str(dbrow[23 + ZBX_HOST_TLS_OFFSET], proxy->proxy_address))
 			return FAIL;
 
-		if (FAIL == dbsync_compare_uchar(dbrow[32 + ZBX_HOST_TLS_OFFSET], proxy->auto_compress))
+		if (FAIL == dbsync_compare_uchar(dbrow[24 + ZBX_HOST_TLS_OFFSET], proxy->auto_compress))
 			return FAIL;
 	}
 
@@ -618,9 +618,7 @@ int	zbx_dbsync_compare_hosts(zbx_dbsync_t *sync)
 	if (NULL == (result = DBselect(
 			"select hostid,proxy_hostid,host,ipmi_authtype,ipmi_privilege,ipmi_username,"
 				"ipmi_password,maintenance_status,maintenance_type,maintenance_from,"
-				"errors_from,available,disable_until,snmp_errors_from,"
-				"snmp_available,snmp_disable_until,ipmi_errors_from,ipmi_available,"
-				"ipmi_disable_until,jmx_errors_from,jmx_available,jmx_disable_until,"
+				"available,snmp_available,ipmi_available,jmx_available,"
 				"status,name,lastaccess,error,snmp_error,ipmi_error,jmx_error,tls_connect,tls_accept"
 				",tls_issuer,tls_subject,tls_psk_identity,tls_psk,proxy_address,auto_compress"
 			" from hosts"
@@ -633,14 +631,12 @@ int	zbx_dbsync_compare_hosts(zbx_dbsync_t *sync)
 		return FAIL;
 	}
 
-	dbsync_prepare(sync, 37, NULL);
+	dbsync_prepare(sync, 29, NULL);
 #else
 	if (NULL == (result = DBselect(
 			"select hostid,proxy_hostid,host,ipmi_authtype,ipmi_privilege,ipmi_username,"
 				"ipmi_password,maintenance_status,maintenance_type,maintenance_from,"
-				"errors_from,available,disable_until,snmp_errors_from,"
-				"snmp_available,snmp_disable_until,ipmi_errors_from,ipmi_available,"
-				"ipmi_disable_until,jmx_errors_from,jmx_available,jmx_disable_until,"
+				"available,snmp_available,ipmi_available,jmx_available,"
 				"status,name,lastaccess,error,snmp_error,ipmi_error,jmx_error,tls_connect,tls_accept,"
 				"proxy_address,auto_compress"
 			" from hosts"
@@ -653,7 +649,7 @@ int	zbx_dbsync_compare_hosts(zbx_dbsync_t *sync)
 		return FAIL;
 	}
 
-	dbsync_prepare(sync, 33, NULL);
+	dbsync_prepare(sync, 25, NULL);
 #endif
 
 	if (ZBX_DBSYNC_INIT == sync->mode)
diff --git a/src/libs/zbxdbhigh/db.c b/src/libs/zbxdbhigh/db.c
index 1e4ee18..966e0a5 100644
--- a/src/libs/zbxdbhigh/db.c
+++ b/src/libs/zbxdbhigh/db.c
@@ -2796,72 +2796,6 @@ int	DBlock_records(const char *table, const zbx_vector_uint64_t *ids)
 
 /******************************************************************************
  *                                                                            *
- * Function: zbx_sql_add_host_availability                                    *
- *                                                                            *
- * Purpose: adds host availability update to sql statement                    *
- *                                                                            *
- * Parameters: sql        - [IN/OUT] the sql statement                        *
- *             sql_alloc  - [IN/OUT] the number of bytes allocated for sql    *
- *                                   statement                                *
- *             sql_offset - [IN/OUT] the number of bytes used in sql          *
- *                                   statement                                *
- *             ha           [IN] the host availability data                   *
- *                                                                            *
- ******************************************************************************/
-int	zbx_sql_add_host_availability(char **sql, size_t *sql_alloc, size_t *sql_offset,
-		const zbx_host_availability_t *ha)
-{
-	const char	*field_prefix[ZBX_AGENT_MAX] = {"", "snmp_", "ipmi_", "jmx_"};
-	char		delim = ' ';
-	int		i;
-
-	if (FAIL == zbx_host_availability_is_set(ha))
-		return FAIL;
-
-	zbx_strcpy_alloc(sql, sql_alloc, sql_offset, "update hosts set");
-
-	for (i = 0; i < ZBX_AGENT_MAX; i++)
-	{
-		if (0 != (ha->agents[i].flags & ZBX_FLAGS_AGENT_STATUS_AVAILABLE))
-		{
-			zbx_snprintf_alloc(sql, sql_alloc, sql_offset, "%c%savailable=%d", delim, field_prefix[i],
-					(int)ha->agents[i].available);
-			delim = ',';
-		}
-
-		if (0 != (ha->agents[i].flags & ZBX_FLAGS_AGENT_STATUS_ERROR))
-		{
-			char	*error_esc;
-
-			error_esc = DBdyn_escape_field("hosts", "error", ha->agents[i].error);
-			zbx_snprintf_alloc(sql, sql_alloc, sql_offset, "%c%serror='%s'", delim, field_prefix[i],
-					error_esc);
-			zbx_free(error_esc);
-			delim = ',';
-		}
-
-		if (0 != (ha->agents[i].flags & ZBX_FLAGS_AGENT_STATUS_ERRORS_FROM))
-		{
-			zbx_snprintf_alloc(sql, sql_alloc, sql_offset, "%c%serrors_from=%d", delim, field_prefix[i],
-					ha->agents[i].errors_from);
-			delim = ',';
-		}
-
-		if (0 != (ha->agents[i].flags & ZBX_FLAGS_AGENT_STATUS_DISABLE_UNTIL))
-		{
-			zbx_snprintf_alloc(sql, sql_alloc, sql_offset, "%c%sdisable_until=%d", delim, field_prefix[i],
-					ha->agents[i].disable_until);
-			delim = ',';
-		}
-	}
-
-	zbx_snprintf_alloc(sql, sql_alloc, sql_offset, " where hostid=" ZBX_FS_UI64, ha->hostid);
-
-	return SUCCEED;
-}
-
-/******************************************************************************
- *                                                                            *
  * Function: DBget_user_by_active_session                                     *
  *                                                                            *
  * Purpose: validate that session is active and get associated user data      *
diff --git a/src/libs/zbxdbhigh/proxy.c b/src/libs/zbxdbhigh/proxy.c
index e33e1b1..11e3645 100644
--- a/src/libs/zbxdbhigh/proxy.c
+++ b/src/libs/zbxdbhigh/proxy.c
@@ -1480,7 +1480,7 @@ static int	process_proxyconfig_table(const ZBX_TABLE *table, struct zbx_json_par
 	{
 		zbx_vector_uint64_sort(&availability_hostids, ZBX_DEFAULT_UINT64_COMPARE_FUNC);
 		zbx_vector_uint64_uniq(&availability_hostids, ZBX_DEFAULT_UINT64_COMPARE_FUNC);
-		DCtouch_hosts_availability(&availability_hostids);
+		zbx_dc_refresh_hosts_availability(&availability_hostids);
 	}
 clean:
 	if (0 != ins.values_num)
@@ -1614,10 +1614,7 @@ void	process_proxyconfig(struct zbx_json_parse *jp_data)
 				(NULL == error ? "database error" : error));
 	}
 	else
-	{
 		DCsync_configuration(ZBX_DBSYNC_UPDATE);
-		DCupdate_hosts_availability();
-	}
 
 	zbx_free(error);
 
@@ -1632,45 +1629,47 @@ void	process_proxyconfig(struct zbx_json_parse *jp_data)
  *                FAIL - no host availability has been changed                *
  *                                                                            *
  ******************************************************************************/
-int	get_host_availability_data(struct zbx_json *json, int *ts)
+int	get_host_availability_data(struct zbx_json *json, zbx_vector_ptr_t *updates)
 {
 	const char			*__function_name = "get_host_availability_data";
-	int				i, j, ret = FAIL;
-	zbx_vector_ptr_t		hosts;
-	zbx_host_availability_t		*ha;
+	int				i, ret = FAIL;
+	zbx_agent_status_update_t	*update;
+	zbx_uint64_t			hostid = 0;
+	const char			*error;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
 
-	zbx_vector_ptr_create(&hosts);
-
-	if (SUCCEED != DCget_hosts_availability(&hosts, ts))
+	if (SUCCEED != zbx_dc_get_host_availability_updates(updates))
 		goto out;
 
 	zbx_json_addarray(json, ZBX_PROTO_TAG_HOST_AVAILABILITY);
 
-	for (i = 0; i < hosts.values_num; i++)
+	for (i = 0; i < updates->values_num; i++)
 	{
-		ha = (zbx_host_availability_t *)hosts.values[i];
+		update = (zbx_agent_status_update_t *)updates->values[i];
 
-		zbx_json_addobject(json, NULL);
-		zbx_json_adduint64(json, ZBX_PROTO_TAG_HOSTID, ha->hostid);
-
-		for (j = 0; j < ZBX_AGENT_MAX; j++)
+		if (update->hostid != hostid)
 		{
-			zbx_json_adduint64(json, availability_tag_available[j], ha->agents[j].available);
-			zbx_json_addstring(json, availability_tag_error[j], ha->agents[j].error, ZBX_JSON_TYPE_STRING);
+			if (0 != hostid)
+				zbx_json_close(json);
+
+			zbx_json_addobject(json, NULL);
+			zbx_json_adduint64(json, ZBX_PROTO_TAG_HOSTID, update->hostid);
+
+			hostid = update->hostid;
 		}
 
-		zbx_json_close(json);
+		error = (HOST_AVAILABLE_FALSE == update->available ? update->error : "");
+
+		zbx_json_adduint64(json, availability_tag_available[update->type], update->available);
+		zbx_json_addstring(json, availability_tag_error[update->type], error, ZBX_JSON_TYPE_STRING);
 	}
 
 	zbx_json_close(json);
+	zbx_json_close(json);
 
 	ret = SUCCEED;
 out:
-	zbx_vector_ptr_clear_ext(&hosts, (zbx_mem_free_func_t)zbx_host_availability_free);
-	zbx_vector_ptr_destroy(&hosts);
-
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __function_name, zbx_result_string(ret));
 
 	return ret;
@@ -1688,18 +1687,18 @@ out:
  ******************************************************************************/
 static int	process_host_availability_contents(struct zbx_json_parse *jp_data, char **error)
 {
-	zbx_uint64_t		hostid;
-	struct zbx_json_parse	jp_row;
-	const char		*p = NULL;
-	char			*tmp = NULL;
-	size_t			tmp_alloc = 129;
-	zbx_host_availability_t	*ha = NULL;
-	zbx_vector_ptr_t	hosts;
-	int			i, ret;
+	zbx_uint64_t			hostid;
+	struct zbx_json_parse		jp_row;
+	const char			*p = NULL;
+	char				*tmp = NULL;
+	size_t				tmp_alloc = 129;
+	zbx_agent_status_update_t	*update;
+	zbx_vector_ptr_t		updates;
+	int				i, ret;
 
 	tmp = (char *)zbx_malloc(NULL, tmp_alloc);
 
-	zbx_vector_ptr_create(&hosts);
+	zbx_vector_ptr_create(&updates);
 
 	while (NULL != (p = zbx_json_next(jp_data, p)))	/* iterate the host entries */
 	{
@@ -1721,9 +1720,6 @@ static int	process_host_availability_contents(struct zbx_json_parse *jp_data, ch
 			goto out;
 		}
 
-		ha = (zbx_host_availability_t *)zbx_malloc(NULL, sizeof(zbx_host_availability_t));
-		zbx_host_availability_init(ha, hostid);
-
 		for (i = 0; i < ZBX_AGENT_MAX; i++)
 		{
 			if (SUCCEED != zbx_json_value_by_name_dyn(&jp_row, availability_tag_available[i], &tmp,
@@ -1732,62 +1728,29 @@ static int	process_host_availability_contents(struct zbx_json_parse *jp_data, ch
 				continue;
 			}
 
-			ha->agents[i].available = atoi(tmp);
-			ha->agents[i].flags |= ZBX_FLAGS_AGENT_STATUS_AVAILABLE;
-		}
-
-		for (i = 0; i < ZBX_AGENT_MAX; i++)
-		{
-			if (SUCCEED != zbx_json_value_by_name_dyn(&jp_row, availability_tag_error[i], &tmp, &tmp_alloc))
-				continue;
+			update = (zbx_agent_status_update_t *)zbx_malloc(NULL, sizeof(zbx_agent_status_update_t));
+			update->hostid = hostid;
+			update->flags = ZBX_AGENT_STATUS_AVAILABLE;
+			update->type = i;
+			update->available = atoi(tmp);
 
-			ha->agents[i].error = zbx_strdup(NULL, tmp);
-			ha->agents[i].flags |= ZBX_FLAGS_AGENT_STATUS_ERROR;
-		}
+			if (SUCCEED == zbx_json_value_by_name_dyn(&jp_row, availability_tag_error[i], &tmp, &tmp_alloc))
+			{
+				update->flags |= ZBX_AGENT_STATUS_ERROR;
+				update->error = zbx_strdup(NULL, tmp);
+			}
 
-		if (SUCCEED != (ret = zbx_host_availability_is_set(ha)))
-		{
-			zbx_free(ha);
-			*error = zbx_dsprintf(*error, "no availability data for \"hostid\":" ZBX_FS_UI64, hostid);
-			goto out;
+			zbx_vector_ptr_append(&updates, update);
 		}
-
-		zbx_vector_ptr_append(&hosts, ha);
 	}
 
-	if (0 < hosts.values_num && SUCCEED == DCset_hosts_availability(&hosts))
-	{
-		int	i;
-		char	*sql = NULL;
-		size_t	sql_alloc = 4 * ZBX_KIBIBYTE, sql_offset = 0;
-
-		sql = (char *)zbx_malloc(sql, sql_alloc);
-
-		DBbegin();
-		DBbegin_multiple_update(&sql, &sql_alloc, &sql_offset);
-
-		for (i = 0; i < hosts.values_num; i++)
-		{
-			if (SUCCEED == zbx_sql_add_host_availability(&sql, &sql_alloc, &sql_offset, (zbx_host_availability_t *)hosts.values[i]))
-				zbx_strcpy_alloc(&sql, &sql_alloc, &sql_offset, ";\n");
-
-			DBexecute_overflowed_sql(&sql, &sql_alloc, &sql_offset);
-		}
-
-		DBend_multiple_update(&sql, &sql_alloc, &sql_offset);
-
-		if (16 < sql_offset)
-			DBexecute("%s", sql);
-
-		DBcommit();
-
-		zbx_free(sql);
-	}
+	if (0 != updates.values_num)
+		zbx_dc_update_proxy_host_availability(&updates);
 
 	ret = SUCCEED;
 out:
-	zbx_vector_ptr_clear_ext(&hosts, (zbx_mem_free_func_t)zbx_host_availability_free);
-	zbx_vector_ptr_destroy(&hosts);
+	zbx_vector_ptr_clear_ext(&updates, zbx_agent_status_update_free);
+	zbx_vector_ptr_destroy(&updates);
 
 	zbx_free(tmp);
 
diff --git a/src/libs/zbxself/selfmon.c b/src/libs/zbxself/selfmon.c
index 6b53782..bca7f91 100644
--- a/src/libs/zbxself/selfmon.c
+++ b/src/libs/zbxself/selfmon.c
@@ -115,6 +115,7 @@ extern int	CONFIG_IPMIMANAGER_FORKS;
 extern int	CONFIG_ALERTMANAGER_FORKS;
 extern int	CONFIG_PREPROCMAN_FORKS;
 extern int	CONFIG_PREPROCESSOR_FORKS;
+extern int	CONFIG_AVAILABILITYSYNCER_FORKS;
 
 extern unsigned char	process_type;
 extern int		process_num;
@@ -192,6 +193,8 @@ int	get_process_type_forks(unsigned char proc_type)
 			return CONFIG_PREPROCMAN_FORKS;
 		case ZBX_PROCESS_TYPE_PREPROCESSOR:
 			return CONFIG_PREPROCESSOR_FORKS;
+		case ZBX_PROCESS_TYPE_AVAILABILITY_SYNCER:
+			return CONFIG_AVAILABILITYSYNCER_FORKS;
 	}
 
 	THIS_SHOULD_NEVER_HAPPEN;
diff --git a/src/zabbix_agent/zabbix_agentd.c b/src/zabbix_agent/zabbix_agentd.c
index 0e39c20..9e95a32 100644
--- a/src/zabbix_agent/zabbix_agentd.c
+++ b/src/zabbix_agent/zabbix_agentd.c
@@ -266,6 +266,7 @@ int	CONFIG_IPMIMANAGER_FORKS	= 0;
 int	CONFIG_ALERTMANAGER_FORKS	= 0;
 int	CONFIG_PREPROCMAN_FORKS		= 0;
 int	CONFIG_PREPROCESSOR_FORKS	= 0;
+int	CONFIG_AVAILABILITYSYNCER_FORKS	= 0;
 
 char	*opt = NULL;
 
diff --git a/src/zabbix_proxy/datasender/datasender.c b/src/zabbix_proxy/datasender/datasender.c
index 91761ee..5a327d9 100644
--- a/src/zabbix_proxy/datasender/datasender.c
+++ b/src/zabbix_proxy/datasender/datasender.c
@@ -64,15 +64,17 @@ static int	proxy_data_sender(int *more, int now)
 	zbx_socket_t		sock;
 	struct zbx_json		j;
 	struct zbx_json_parse	jp, jp_tasks;
-	int			availability_ts, history_records = 0, discovery_records = 0,
+	int			history_records = 0, discovery_records = 0,
 				areg_records = 0, more_history = 0, more_discovery = 0, more_areg = 0;
 	zbx_uint64_t		history_lastid = 0, discovery_lastid = 0, areg_lastid = 0, flags = 0;
 	zbx_timespec_t		ts;
 	char			*error = NULL;
-	zbx_vector_ptr_t	tasks;
+	zbx_vector_ptr_t	tasks, availability;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
 
+	zbx_vector_ptr_create(&availability);
+
 	*more = ZBX_PROXY_DATA_DONE;
 	zbx_json_init(&j, 16 * ZBX_KIBIBYTE);
 
@@ -81,7 +83,7 @@ static int	proxy_data_sender(int *more, int now)
 
 	if (SUCCEED == upload_state && CONFIG_PROXYDATA_FREQUENCY <= now - data_timestamp)
 	{
-		if (SUCCEED == get_host_availability_data(&j, &availability_ts))
+		if (SUCCEED == get_host_availability_data(&j, &availability))
 			flags |= ZBX_DATASENDER_AVAILABILITY;
 
 		if  (0 != (history_records = proxy_get_hist_data(&j, &history_lastid, &more_history)))
@@ -143,12 +145,12 @@ static int	proxy_data_sender(int *more, int now)
 			zabbix_log(LOG_LEVEL_WARNING, "cannot send proxy data to server at \"%s\": %s",
 					sock.peer, error);
 			zbx_free(error);
+
+			if (0 != (flags & ZBX_DATASENDER_AVAILABILITY))
+				zbx_refresh_host_availability(&availability);
 		}
 		else
 		{
-			if (0 != (flags & ZBX_DATASENDER_AVAILABILITY))
-				zbx_set_availability_diff_ts(availability_ts);
-
 			if (SUCCEED == zbx_json_open(sock.buffer, &jp))
 			{
 				if (SUCCEED == zbx_json_brackets_by_name(&jp, ZBX_PROTO_TAG_TASKS, &jp_tasks))
@@ -190,6 +192,9 @@ static int	proxy_data_sender(int *more, int now)
 	zbx_vector_ptr_clear_ext(&tasks, (zbx_clean_func_t)zbx_tm_task_free);
 	zbx_vector_ptr_destroy(&tasks);
 
+	zbx_vector_ptr_clear_ext(&availability, zbx_agent_status_update_free);
+	zbx_vector_ptr_destroy(&availability);
+
 	zbx_json_free(&j);
 
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s more:%d flags:0x" ZBX_FS_UX64, __function_name,
diff --git a/src/zabbix_proxy/proxy.c b/src/zabbix_proxy/proxy.c
index eb12322..a097219 100644
--- a/src/zabbix_proxy/proxy.c
+++ b/src/zabbix_proxy/proxy.c
@@ -162,6 +162,7 @@ int	CONFIG_IPMIMANAGER_FORKS	= 0;
 int	CONFIG_ALERTMANAGER_FORKS	= 0;
 int	CONFIG_PREPROCMAN_FORKS		= 0;
 int	CONFIG_PREPROCESSOR_FORKS	= 0;
+int	CONFIG_AVAILABILITYSYNCER_FORKS	= 1;
 
 int	CONFIG_LISTEN_PORT		= ZBX_DEFAULT_SERVER_PORT;
 char	*CONFIG_LISTEN_IP		= NULL;
diff --git a/src/zabbix_server/Makefile.am b/src/zabbix_server/Makefile.am
index 4348e31..bd45fe4 100644
--- a/src/zabbix_server/Makefile.am
+++ b/src/zabbix_server/Makefile.am
@@ -20,7 +20,8 @@ SUBDIRS = \
 	ipmi \
 	odbc \
 	scripts \
-	preprocessor
+	preprocessor \
+	availability
 
 sbin_PROGRAMS = zabbix_server
 
@@ -62,6 +63,7 @@ zabbix_server_LDADD = \
 	odbc/libzbxodbc.a \
 	scripts/libzbxscripts.a \
 	preprocessor/libpreprocessor.a \
+	availability/libzbxavailability.a \
 	$(top_srcdir)/src/libs/zbxsysinfo/libzbxserversysinfo.a \
 	$(top_srcdir)/src/libs/zbxsysinfo/common/libcommonsysinfo.a \
 	$(top_srcdir)/src/libs/zbxsysinfo/simple/libsimplesysinfo.a \
diff --git a/src/zabbix_server/availability/Makefile.am b/src/zabbix_server/availability/Makefile.am
new file mode 100644
index 0000000..ec2a94e
--- /dev/null
+++ b/src/zabbix_server/availability/Makefile.am
@@ -0,0 +1,5 @@
+## Process this file with automake to produce Makefile.in
+
+noinst_LIBRARIES = libzbxavailability.a
+
+libzbxavailability_a_SOURCES = availability.c availability.h
diff --git a/src/zabbix_server/availability/availability.c b/src/zabbix_server/availability/availability.c
new file mode 100644
index 0000000..eb23790
--- /dev/null
+++ b/src/zabbix_server/availability/availability.c
@@ -0,0 +1,197 @@
+/*
+** Zabbix
+** Copyright (C) 2001-2018 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+#include "common.h"
+
+#include "db.h"
+#include "dbcache.h"
+#include "log.h"
+#include "daemon.h"
+#include "zbxself.h"
+
+#include "availability.h"
+#include "export.h"
+
+#define ZBX_AVAILABILITY_SYNCER_DELAY		1
+extern unsigned char	process_type, program_type;
+extern int		server_num, process_num;
+
+static int	db_flush_host_availability(const zbx_vector_ptr_t *updates)
+{
+	int		i;
+	char		*sql = NULL, delim, *error_esc, *agents[] = {"", "snmp_", "ipmi_", "jmx_"};
+	size_t		sql_alloc = 0, sql_offset = 0;
+	zbx_uint64_t	hostid;
+
+
+	DBbegin();
+	DBbegin_multiple_update(&sql, &sql_alloc, &sql_offset);
+
+	delim = ' ';
+	hostid = ((const zbx_agent_status_update_t *)updates->values[0])->hostid;
+	zbx_strcpy_alloc(&sql, &sql_alloc, &sql_offset, "update hosts set");
+
+	for (i = 0; i < updates->values_num; i++)
+	{
+		const zbx_agent_status_update_t	*update = (const zbx_agent_status_update_t *)updates->values[i];
+
+		if (hostid != update->hostid)
+		{
+			zbx_snprintf_alloc(&sql, &sql_alloc, &sql_offset, " where hostid=" ZBX_FS_UI64 ";\n", hostid);
+			if (SUCCEED != DBexecute_overflowed_sql(&sql, &sql_alloc, &sql_offset))
+				goto out;
+
+			delim = ' ';
+			hostid = update->hostid;
+			zbx_strcpy_alloc(&sql, &sql_alloc, &sql_offset, "update hosts set");
+		}
+
+		if (0 != (update->flags & ZBX_AGENT_STATUS_AVAILABLE))
+		{
+			zbx_snprintf_alloc(&sql, &sql_alloc, &sql_offset, "%c%savailable=%d", delim,
+					agents[update->type], update->available);
+			delim = ',';
+		}
+
+		if (0 != (update->flags & ZBX_AGENT_STATUS_ERROR))
+		{
+			error_esc = DBdyn_escape_string_len(update->error, HOST_ERROR_LEN);
+			zbx_snprintf_alloc(&sql, &sql_alloc, &sql_offset, "%c%serror='%s'", delim,
+					agents[update->type], error_esc);
+			delim = ',';
+			zbx_free(error_esc);
+		}
+	}
+
+	zbx_snprintf_alloc(&sql, &sql_alloc, &sql_offset, " where hostid=" ZBX_FS_UI64 ";\n", hostid);
+	if (SUCCEED != DBexecute_overflowed_sql(&sql, &sql_alloc, &sql_offset))
+		goto out;
+
+	DBend_multiple_update(&sql, &sql_alloc, &sql_offset);
+
+
+	if (16 < sql_offset)
+		DBexecute("%s", sql);
+
+out:
+	zbx_free(sql);
+
+	return DBcommit();
+}
+
+static int	sync_availability()
+{
+	zbx_vector_ptr_t	updates;
+	int			ret = 0;
+
+	zbx_vector_ptr_create(&updates);
+	if (SUCCEED != zbx_dc_get_host_availability_updates(&updates))
+		goto out;
+
+	ret = updates.values_num;
+
+	zbx_vector_ptr_sort(&updates, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
+
+	while (ZBX_DB_DOWN == db_flush_host_availability(&updates))
+		;
+
+	zbx_vector_ptr_clear_ext(&updates, zbx_agent_status_update_free);
+out:
+	zbx_vector_ptr_destroy(&updates);
+
+	return ret;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: availability_syncer                                              *
+ *                                                                            *
+ * Purpose: periodically synchronizes cached host availability data with      *
+ *          database.                                                         *
+ *                                                                            *
+ ******************************************************************************/
+ZBX_THREAD_ENTRY(availability_syncer_thread, args)
+{
+	int	sleeptime = -1, num = 0, old_num = 0, sync_num;
+	double	sec, total_sec = 0.0, old_total_sec = 0.0;
+	time_t	last_stat_time;
+
+	process_type = ((zbx_thread_args_t *)args)->process_type;
+	server_num = ((zbx_thread_args_t *)args)->server_num;
+	process_num = ((zbx_thread_args_t *)args)->process_num;
+
+	zabbix_log(LOG_LEVEL_INFORMATION, "%s #%d started [%s #%d]", get_program_type_string(program_type),
+			server_num, get_process_type_string(process_type), process_num);
+
+#define STAT_INTERVAL	5	/* if a process is busy and does not sleep then update status not faster than */
+				/* once in STAT_INTERVAL seconds */
+
+	zbx_setproctitle("%s #%d [connecting to the database]", get_process_type_string(process_type), process_num);
+	last_stat_time = time(NULL);
+
+	DBconnect(ZBX_DB_CONNECT_NORMAL);
+
+	for (;;)
+	{
+		zbx_handle_log();
+
+		if (0 != sleeptime)
+		{
+			zbx_setproctitle("%s #%d [synced %d hosts in " ZBX_FS_DBL " sec, syncing availability]",
+					get_process_type_string(process_type), process_num, old_num, old_total_sec);
+		}
+
+		sec = zbx_time();
+
+		sync_num = sync_availability();
+
+		num += sync_num;
+		total_sec += zbx_time() - sec;
+
+		sleeptime = ZBX_AVAILABILITY_SYNCER_DELAY;
+
+		if (0 != sleeptime || STAT_INTERVAL <= time(NULL) - last_stat_time)
+		{
+			if (0 == sleeptime)
+			{
+				zbx_setproctitle("%s #%d [synced %d hosts in " ZBX_FS_DBL " sec, syncing availability]",
+						get_process_type_string(process_type), process_num, num, total_sec);
+			}
+			else
+			{
+				zbx_setproctitle("%s #%d [synced %d hosts in " ZBX_FS_DBL " sec, idle %d sec]",
+						get_process_type_string(process_type), process_num, num, total_sec,
+						sleeptime);
+				old_num = num;
+				old_total_sec = total_sec;
+			}
+			num = 0;
+			total_sec = 0.0;
+			last_stat_time = time(NULL);
+		}
+
+		zbx_sleep_loop(sleeptime);
+
+#if !defined(_WINDOWS) && defined(HAVE_RESOLV_H)
+		zbx_update_resolver_conf();	/* handle /etc/resolv.conf update */
+#endif
+	}
+
+#undef STAT_INTERVAL
+}
diff --git a/src/zabbix_server/availability/availability.h b/src/zabbix_server/availability/availability.h
new file mode 100644
index 0000000..c6e9ac0
--- /dev/null
+++ b/src/zabbix_server/availability/availability.h
@@ -0,0 +1,27 @@
+/*
+** Zabbix
+** Copyright (C) 2001-2018 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+#ifndef ZABBIX_AVAILABILITY_H
+#define ZABBIX_AVAILABILITY_H
+
+#include "threads.h"
+
+ZBX_THREAD_ENTRY(availability_syncer_thread, args);
+
+#endif
diff --git a/src/zabbix_server/dbconfig/dbconfig.c b/src/zabbix_server/dbconfig/dbconfig.c
index 4e3df16..631b792 100644
--- a/src/zabbix_server/dbconfig/dbconfig.c
+++ b/src/zabbix_server/dbconfig/dbconfig.c
@@ -91,7 +91,7 @@ ZBX_THREAD_ENTRY(dbconfig_thread, args)
 
 		sec = zbx_time();
 		DCsync_configuration(ZBX_DBSYNC_UPDATE);
-		DCupdate_hosts_availability();
+		zbx_dc_reset_proxy_hosts_availability();
 		dc_flush_history();	/* misconfigured items generate pseudo-historic values to become notsupported */
 		sec = zbx_time() - sec;
 
diff --git a/src/zabbix_server/poller/checks_internal.c b/src/zabbix_server/poller/checks_internal.c
index d6f5892..0488042 100644
--- a/src/zabbix_server/poller/checks_internal.c
+++ b/src/zabbix_server/poller/checks_internal.c
@@ -342,23 +342,41 @@ int	get_value_internal(DC_ITEM *item, AGENT_RESULT *result)
 
 		if (0 == strcmp(tmp, "available"))		/* zabbix["host",<type>,"available"] */
 		{
+			zbx_agent_status_t	agents[ZBX_AGENT_MAX];
+			int			index = -1;
+
 			tmp = get_rparam(&request, 1);
 
 			if (0 == strcmp(tmp, "agent"))
-				SET_UI64_RESULT(result, item->host.available);
+				index = ZBX_AGENT_ZABBIX;
 			else if (0 == strcmp(tmp, "snmp"))
-				SET_UI64_RESULT(result, item->host.snmp_available);
+				index = ZBX_AGENT_SNMP;
 			else if (0 == strcmp(tmp, "ipmi"))
-				SET_UI64_RESULT(result, item->host.ipmi_available);
+				index = ZBX_AGENT_IPMI;
 			else if (0 == strcmp(tmp, "jmx"))
-				SET_UI64_RESULT(result, item->host.jmx_available);
+				index = ZBX_AGENT_JMX;
 			else
 			{
 				SET_MSG_RESULT(result, zbx_strdup(NULL, "Invalid second parameter."));
 				goto out;
 			}
 
-			result->ui64 = 2 - result->ui64;
+			zbx_dc_get_host_availability(item->host.hostid, agents);
+
+			switch (agents[index].available)
+			{
+				case HOST_AVAILABLE_TRUE:
+					SET_UI64_RESULT(result, 1);
+					break;
+				case HOST_AVAILABLE_FALSE:
+					SET_UI64_RESULT(result, 0);
+					break;
+				case HOST_AVAILABLE_UNKNOWN:
+					SET_UI64_RESULT(result, 2);
+					break;
+			}
+
+			zbx_dc_clean_host_availability(agents);
 		}
 		else if (0 == strcmp(tmp, "maintenance"))	/* zabbix["host",,"maintenance"] */
 		{
